/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, markType, getInstanceType } from "igniteui-react-core";
import { IIndicatorProxy_$type } from "./IIndicatorProxy";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
/**
 * @hidden
 */
export let IndicatorProxy = /*@__PURE__*/ (() => {
    class IndicatorProxy extends Base {
        matchesType(a) {
            if (a.el) {
                return true;
            }
            return false;
        }
        setCloseMemberPath(a, b) {
            a.wd = b;
        }
        setDisplayType(a, b) {
            a.x6 = b;
        }
        setHighMemberPath(a, b) {
            a.wq = b;
        }
        setLongPeriod(a, b) {
            if (typeCast(IShortPeriodLongPeriod_$type, a) !== null) {
                a.longPeriod = b;
            }
        }
        setLowMemberPath(a, b) {
            a.wv = b;
        }
        setNegativeBrush(a, b) {
            a.xz = b;
        }
        setOpenMemberPath(a, b) {
            a.wz = b;
        }
        setPeriodOverride(a, b) {
            if (typeCast(StrategyBasedIndicator.$, a) !== null) {
                a.zd(b);
            }
        }
        setShortPeriod(a, b) {
            if (typeCast(IShortPeriodLongPeriod_$type, a) !== null) {
                a.shortPeriod = b;
            }
        }
        setSignalPeriod(a, b) {
            if (getInstanceType(a).typeName == "MovingAverageConvergenceDivergenceIndicator") {
                let s_ = a;
                let p_ = b;
                s_['signalPeriod'] = p_;
            }
        }
        setSmoothingPeriod(a, b) {
            if (getInstanceType(a).typeName == "FullStochasticOscillatorIndicator") {
                let s_ = a;
                let p_ = b;
                s_['smoothingPeriod'] = p_;
            }
        }
        setVolumeMemberPath(a, b) {
            a.w3 = b;
        }
        setXAxis(a, b) {
            a.t9 = b;
        }
        setYAxis(a, b) {
            a.uv = b;
        }
        handleCustomIndicatorEvent(a, b) {
            if (getInstanceType(a).typeName == "CustomIndicator") {
                let s_ = a;
                let p_ = b;
                s_['indicator'] = p_;
            }
        }
        setMultiplier(a, b) {
            if (getInstanceType(a).typeName == "BollingerBandWidthIndicator") {
                let s_ = a;
                let p_ = b;
                s_['multiplier'] = p_;
            }
        }
    }
    IndicatorProxy.$t = /*@__PURE__*/ markType(IndicatorProxy, 'IndicatorProxy', Base.$, [IIndicatorProxy_$type]);
    return IndicatorProxy;
})();
